/* Init*/
var form=document.getElementById("form");
var title_input=document.getElementById("title");
var content_textarea=document.getElementById("id_content");
var file_input=document.getElementById("files");
var filter_input=document.getElementById("filter");
var pic=document.getElementById("pic");
var gallery=document.getElementById("images");
var resized_canvas=[];
var nofilter_imgs=[];
var resized_imgs=[];



/* functions */ 
function cleanGallery(){ 
	//reset le bouzin (utile si on se ravise et qu'on veut resélectionner de nouvelles images)
	resized_canvas=[];
	nofilter_imgs=[];
	resized_imgs=[];
	filenames=[];
	filter_input.selectedIndex=0;
	
	while (gallery.firstChild) {
		gallery.removeChild(gallery.firstChild);
	}
	return gallery;
}

function files2originalImgs(files){
	// utilise l'input files pour init le tableau d'images originales. 
	let original_imgs=[];
	for (file of files){
		let img=document.createElement('img');
		img.src=URL.createObjectURL(file);
		original_imgs.push(img);

	}
	return original_imgs;
}

function applyFilter(){// pas besoin d'explications, si ?! (ʘ‿↼)
	let l=resized_canvas.length;console.log(l,resized_imgs.length)	;
	for (i=0;i<l;i++){console.log(i);
		let current_canvas=resized_canvas[i];
		let ctx=current_canvas.getContext('2d');
		ctx.filter=filter.value;		
		ctx.drawImage(nofilter_imgs[i],0,0,current_canvas.width,current_canvas.height);
		resized_imgs[i].src=current_canvas.toDataURL('image/jpeg');
		
	}

	
	document.getElementById("pic").src=resized_imgs[0].src;
}

// si on clique sur une image de la galerie, elle passe en image de titre et l'image de titre passe dans la galerie
// ça permet de choisir l'image principale vu que les images sont ajoutées dans la galerie en fonction de la vitesse à laquelle elles sont load. 
// (ಠ_ಠ)
function makeFirst(pic){
	let clicked_index   =pic.alt;
	let filename_clicked=document.getElementById("filename-"+clicked_index);
	let filename_zero 	=document.getElementById("filename-0");
	let data_clicked	=document.getElementById("data-"+clicked_index);
	let data_zero	 	=document.getElementById("data-0");

	// put clicked img in big one
	document.getElementById("pic").src=resized_imgs[clicked_index].src;

	// SWAP VALUES BETWEEN CLICKED AND ZERO
	// swap img.src & title
	[resized_imgs[0].src,resized_imgs[clicked_index].src]=[resized_imgs[clicked_index].src,resized_imgs[0].src];
	// swap no filter imgs src & title
	[nofilter_imgs[0].src,nofilter_imgs[clicked_index].src]=[nofilter_imgs[clicked_index].src,nofilter_imgs[0].src];
	[nofilter_imgs[0].title,nofilter_imgs[clicked_index].title]=[nofilter_imgs[clicked_index].title,nofilter_imgs[0].title];
	// swap working canvas
	[resized_canvas[0].src,resized_canvas[clicked_index].src]=[resized_canvas[clicked_index].src,resized_canvas[0].src];
		
}
function makeHiddenInputs(){
	// génère les inputs hidden à partir des images de la galerie: redimensionnée et filtrées.
	let generated_pictures=document.querySelectorAll('#images img');

	for (let i=0;i<generated_pictures.length;i++){        
		let hiddendata= document.createElement("input");	

        hiddendata.type="hidden";
        hiddendata.name="data["+i+"]";
        hiddendata.value=generated_pictures[i].src;

    	form.appendChild(hiddendata);// ajoute au formulaire
	}
}

/* 
	User selected some files:
	->create gallery

	Pourquoi on fait comme ça ? 
	parce que certaines informations de l'image ne sont disponibles qu'APRES le load (la taille en particulier)
	VIVE L'ASYNCHRONE (╯°□°）╯︵ ┻━┻

	J'en ai chié pour obtenir ça (╬ ಠ益ಠ)
*/
file_input.addEventListener("input", function(event){
	let files=event.target.files;
	//let resizedImage;
	cleanGallery();// si on sélectionne des images, on nettoie la galerie précédente  

	if (files.length>0){
		for (file of files){
		  	if(file.type.match(/image.*/)) {

		        // Load the image
		        let reader = new FileReader();
		        reader.onload = function (readerEvent) {// uniquement une fois chargé
		            let image = new Image(); // on crée une img 
		            image.onload = function (imageEvent) {// uniquement une fois l'img chargé

		            	// on redimensionne l'image puisqu'on a enfin sa taille (après onload)
		                let canvas = document.createElement('canvas'),
		                    //MAX_SIZE = 1200,
		                    width = image.width,
		                    height = image.height;
		                if (width > height) {
		                    if (width > MAX_SIZE) {
		                        height *= MAX_SIZE / width;
		                        width = MAX_SIZE;
		                    }
		                } else {
		                    if (height > MAX_SIZE) {
		                        width *= MAX_SIZE / height;
		                        height = MAX_SIZE;
		                    }
		                }
		                canvas.width = width;
		                canvas.height = height;
		                canvas.getContext('2d').drawImage(image, 0, 0, width, height);

		                let c=resized_imgs.length;
		                resized_canvas[c]=canvas;

		                // une fois l'image redimensionnée si nécessaire, on crée un img à ajouter à la galerie du formulaire
		                let img = new Image();
		                img.src=canvas.toDataURL('image/jpeg');
		                img.width=width;
		                img.height=height;
		                img.alt=c;// sert pour obtenir l'index de l'image cliquée dans la galerie
		                img.setAttribute("onclick","makeFirst(this)");
		                resized_imgs.push(img);

		                let nofilterimg = new Image();
		                nofilterimg.src=img.src;
		                nofilterimg.width=width;
		                nofilterimg.height=height;
		                nofilterimg.alt=c;
		                nofilter_imgs.push(nofilterimg);

		                if (resized_imgs.length==1){
		                	pic.src=img.src;
		                }
		                if(resized_imgs.length>0){
		                	gallery.appendChild(img);
		                }
		            }
		            image.src = readerEvent.target.result;

		        }
		        reader.readAsDataURL(file);
	    	}
		}
		
	}
});

filter.addEventListener("input", function(event){
	applyFilter();// captain obvious inside
});
form.addEventListener("submit", function(event){
	if (event.keyCode==13){
		// submit le formulaire n apuyant sue entrée = PAAAS BIEEEEN !
		event.preventDefault();
		event.stopPropagation();
		event.stopImmediatePropagation();
		return false;
	}
	// vire l'input files (inutile car ne contient que les images non retouchées et alourdit le post)
	file_input.remove();
	// crée les hidden contenant les données base64 des images retouchées
	makeHiddenInputs();

});
title_input.addEventListener("keypress", function(event){
	// passer au textarea sans submit le formulaire
	if (event.keyCode==13){
		event.preventDefault();
		event.stopPropagation();
		event.stopImmediatePropagation();
		content_textarea.focus();
	}
});
